;---------------------------------------------------------------
include  machines.inc
;---------------------------------------------------------------

;---------------------------------------------------------------
;       ReadROM         ; BankNum : bank number
;---------------------------------------------------------------
ReadROM         PROC    near
                CLI
                call    go_ITFmode
                call    MemTransfer
                call    go_BIOSmode
                STI
                ret
ReadROM         ENDP
;---------------------------------------------------------------
go_ITFmode      PROC    near
                wbinvd
                mov     bx,MachineType
                shl     bx,1
                call    PCMC_PCI[bx]
                wbinvd
                mov     dx,043Dh ;      ITF mode
                mov     al,0
                out     dx,al
                mov     dx,043Fh ;      ITF BANK select
                mov     al,BankNum
                shl     al,1
                or      al,0E0h ;       convert to I/O adrress value
                out     dx,al
                cmp     cs:BANK4MHL,1
                jnz     BANK4M_HI
                mov     dx,0B00h        ; I/O 0B00h V@\WX^|[g
                mov     ax,00F0h        ; Command register F0h: A18 line select
                out     dx,ax           
                mov     dx,0B02h        ; I/O 0B02h Data register
                xor     al,al           ; 0= Lower 2Mbit (extended 2Mbit)
                out     dx,al
BANK4M_HI:
                ret
go_ITFmode      ENDP
;---------------------------------------------------------------
go_BIOSmode     PROC    near
                wbinvd
                mov     dx,043Fh        ; ITF BANK select
                mov     al,0E8h         ; to BANK4
                out     dx,al
                mov     dx,043Dh        ; to BIOS mode
                mov     al,2
                out     dx,al

                cmp     cs:BANK4MHL,1
                jnz     BANK4M_HI_e
                mov     dx,0B00h        ; I/O 0B00h V@\WX^|[g
                mov     ax,00F0h        ; Command register F0h: A18 line select
                out     dx,ax
                mov     dx,0B02h        ;  I/O 0B02h Data register
                mov     al,1            ; 0= higher 2Mbit (ordinary 2Mbit)
                out     dx,al

BANK4M_HI_e:    wbinvd
                mov     bx,MachineType
                shl     bx,1
                call    PCMC_RAM[bx]
                ret
go_BIOSmode     ENDP
;-----------------------------------------------------------------------
Detect4M_ROM    PROC    near
                mov     dx,0B00h        ; I/O 0B00h V@\WX^|[g
                mov     ax,0F0h         ; Command register F0h: A18 line select
                out     dx,al
                mov     dx,0B02h        ; I/O 0B02h Data register
                in      al,dx           ; AL=7F 4M bit /  AL=FF 2Mbit
                not     al              ;    80              00
                or      al,al
                jnz     ThisROMis4M
                mov     Bank4MLoop,1      ; 2Mbit
ThisROMis4M:    nop
                ret
Detect4M_ROM    ENDP
;---------------------------------------------------------------
MemTransfer     PROC    near
                les     di,SavedDataDword
                mov     cx,4000h
                push    ds
                lds     si,ITF_win_addr
          rep   movsw
                pop     ds
                ret
MemTransfer     ENDP
ITF_win_addr    dd      0F8000000h

;---------------------------------------------------------------
;       CalcSum_ROM
;---------------------------------------------------------------
CalcSum_ROM     PROC    near
                push    es
                les     bx,SavedDataDword
                mov     cx,4000h ; 4000h-1
                xor     dx,dx
CalcSum_ent:    mov     ax,es:[bx]
                add     bx,2
                add     DL,AL
                add     DH,AH
               loop     CalcSum_ent
                mov     ax,es:[bx]
                pop     es
                ret
CalcSum_ROM     ENDP
;---------------------------------------------------------------
WordSum         dw      00h
;---------------------------------------------------------------
DisplayCheckSum PROC    near
                mov     dx,offset msg_sum0
                call    _puts
                xor     eax,eax
                mov     al,BANK4MHL
                shl     al,3
                add     al,BankNum
                mov     cx,2
                call    digitw
                mov     dx,offset msg_sum1
                call    _puts
                mov     ax,WordSum
                mov     ah,00h

                call    digitx2
                mov     dx,offset msg_sum2
                call    _puts
                mov     ax,WordSum
                xchg    al,ah
                mov     ah,00h

                call    digitx2
                mov     dx,offset msg_sumE
                call    _puts
                ret
msg_sum0   db   0E1h,"Result:  Bank number[",0
msg_sum1   db   0E1h,"]  even SUM =[",0
msg_sum2   db   0E1h,"]   odd SUM =[",0
msg_sumE   db   0E1h,"] .",13,10,0
DisplayCheckSum ENDP
;---------------------------------------------------------------
