;---------------------------------------------------------------
;       CheckMachineEnv
;---------------------------------------------------------------
CheckMachineEnv PROC    near
                mov     dx,offset msg_CheckMachine
                call    _puts

                smsw    ax
                test    al,1
                jnz     Pmode_err
                
                xor     ax,ax   ; 2003-7-10 2.03h  A-mate nC][h
                mov     es,ax   ; ւ̑Ήǉ
                mov     al,es:[0501h]
                test    al,8
                mov     ax,0F8E8h       ; 9821`FbNsegmentm[}
                jz      non_hireso
                mov     ax,0FFE8h       ; 9821`FbNsegmentnC]
non_hireso:     mov     es,ax
                xor     bx,bx
                cmp     es:[bx],2198h   ; 9821`FbN
                jnz     WrongEnv

                mov     bl,3
                mov     al,es:[bx]
                test    al,01001000b    ; m[g@`FbN 2003-7-10 2.03h
                jz      NotNoteMachine
                mov     NoteFlag,1
NotNoteMachine: call    CheckMachineType
                call    _puts
                ret

Pmode_err:      mov     dx,offset err_Pmode
                jmp     DOSabend
WrongEnv:       mov     dx,offset err_WrongEnv
                jmp     DOSabend

msg_CheckMachine DB     0E1h,"Checking machine environment...",13,10,0
err_Pmode       DB      061h,"This program cannot be run in V86 mode.",13,10,0
err_WrongEnv    DB      0E1h,"Machine environment is wrong.",13,10,0
CheckMachineEnv ENDP


;---------------------------------------------------------------
;       ClearCacheTag
;---------------------------------------------------------------
ClearCacheTag   PROC    near
                push    ds
                pushf
                cli
                mov     ax,0F000h
                mov     ds,ax
                mov     si,0
                mov     cx,8000h
          rep   lodsw
                mov     cs:SegBase,1000h
ClearCacheTagEnt:  
                mov     dx,cs:SegBase
                mov     si,0
                mov     cx,8000h
                mov     ds,dx
          rep   lodsw
                add     cs:SegBase,1000h
                cmp     cs:SegBase,9000h
                jb      ClearCacheTagEnt
                popf
                pop     ds
                ret
SegBase         DW      1000h
ClearCacheTag   ENDP
;---------------------------------------------------------------
;       SaveToFile
;---------------------------------------------------------------
SaveToFile      PROC    near
                mov     bx, offset decimal_table
                mov     al,Bank4MHL
                shl     al,3
                add     al, BankNum
                xlat
                mov     bx, offset OutputFileName
                mov     [bx+4],al
                mov     dx, bx
                mov     cx, 0020h
                mov     ax,3C00h
                xor     bx,bx
                int     21h
                jc      creat_err
                mov     DOS_handle,ax
; file write
                mov     bx,DOS_handle
                mov     cx,RomDataSize
                push    ds
                mov     ax,SavedDataSeg
                mov     ds,ax
                mov     dx,0 ; offset 0
                mov     ax,4000h     
                int 21h
                pop     ds
                jc      write_err
                cmp     ax,RomDataSize
                jnz     write_err
                call    CloseFile
                ret
creat_err:      mov     dx,offset CreatErrMsg
                jmp     FileAbend
write_err:      mov     dx,offset WriteErrMsg
                jmp     FileAbend
data_err:       mov     dx,offset DataErrMsg
FileAbend:      jmp     DOSabend
align 2
decimal_table   DB "0123456789ABCDEF"
OutputFileName  DB "BANK4.BIN",0
DOS_handle      DW      0
CreatErrMsg     DB 041h,"File creat error!",13,10,0
WriteErrMsg     DB 041h,"File write error!",13,10,0
DataErrMsg      DB 041h,"Data error!.",13,10,0
SaveToFile      ENDP

;---------------------------------------------------------------
;       CloseFile
;---------------------------------------------------------------
CloseFile       PROC    near
                mov     bx,DOS_handle
                mov     ah,3Eh
                xor     dx,dx
                int     21h
                ret
CloseFile       ENDP

;---------------------------------------------------------------
;       DOSabend
;---------------------------------------------------------------
DOSabend        PROC    near
                call    _puts
                mov     dx,offset msg_DOSabend
                call    _puts
;                call    bellbell
                mov     ah,3
                int 18h
                mov     ax,4CFFh
                int 21h
                ret
msg_DOSabend    DB 0E1h,"ُI܂. ",13,10,0
DOSabend        ENDP

;---------------------------------------------------------------
;       CPUcacheReload 
;---------------------------------------------------------------
CPUcacheReload  PROC    near
                mov     bx,ds
                pushf
                cli
                invd
                mov     dx,043Fh
                mov     al,0A0h
                out     dx,al
                mov     eax,cr0
                and     eax,9FFFFFFFh
                mov     cr0,eax
                popf
                call    ClearCacheTag
                mov     ds,bx
                ret
CPUcacheReload  ENDP

;---------------------------------------------------------------
;       CPUcacheDisable 
;---------------------------------------------------------------
CPUcacheDisable PROC    near
                mov     bx,ds
                call    ClearCacheTag
                pushf
                cli
                mov     ds,bx
                mov     dx,043Fh
                mov     al,0A0h
                out     dx,al
                wbinvd
                mov     eax,cr0         
                or      eax,60000000h   
                mov     cr0,eax         
                popf
                mov     bx,ds
                call    ClearCacheTag
                mov     ds,bx
                ret
CPUcacheDisable ENDP

;---------------------------------------------------------------
;       TerminatePGM
;---------------------------------------------------------------
TerminatePGM    PROC    near
                or      ax,ax
                jz      NoMes
                mov     dx,offset msg_End
                call    _puts
NoMes:          mov     ax,0300h
                int 18h
                mov     ah,01h
                int 18h
                mov     ax,4C00h        ; Terminate and return to DOS
                int 21h
                ret
msg_End         db      0E1h,"I܂.",13,10,0
TerminatePGM    ENDP

;---------------------------------------------------------------
;       MemAlloc        
;---------------------------------------------------------------
MemAlloc        PROC    near
                mov     bx,RomDataSize
                shr     bx,4       ; /  16=paragraph size
                inc     bx
                mov     ax,4800h
                int     21h
                jc      mem_err
                mov     word ptr SavedDataSeg,ax
                les     di,SavedDataDword
                mov     cx,4000h
                mov     ax,0FFFFh
            rep stosw
                clc
                ret
mem_err:        mov     dx,offset msg_mAllocFail
                jmp     DOSabend
                stc
                ret
msg_mAllocFail  db      0E1h,"Insufficient DOS memory.",13,10,0
align   4
SavedDataDword  label dword
SavedDataOfs    DW      00000h
SavedDataSeg    DW      08000h
MemAlloc        ENDP

