;-------------------------------------------
;       Non-wait Keyboard input routine
;-------------------------------------------
KeyInput        PROC    near
                push    bx
                push    cx
                mov     ax,cs
                mov     ds,ax
                xor     ax,ax
                mov     bx,cs:KeyTimeOutCount
                mov     cx,4000h
                cli
                call    Wait15us
KeyInput_ent:   
                in      al,43h
                test    al,02h ; status RDY
                jnz     KeyReady
                dec     cx
                or      cx,cx
                jnz     KeyInput_ent
                jmp     KeyTimeOut
KeyReady:       call    Wait15us
                in      al,41h
                clc
KeyInputEnd:    sti
                pop     cx
                pop     bx
                ret
KeyTimeOut:     mov     al,06h
                out     37h,al

                mov     cx,1000h
KeyBeep:       loop    KeyBeep

                mov     al,07h
                out     37h,al
                mov     cx,0E000h
                dec     bx
                or      bx,bx
                jz      KeyWaitTimeOut
                jmp     KeyInput_ent
KeyWaitTimeOut: ; wait counter time out
;                mov     al,06h 
;                out     37h,al
                stc
                jmp     KeyInputEnd
KeyInput        ENDP
KeyTimeOutCount DW      2400      ; wait counter 

Wait15us        PROC    near
                push    cx
                mov     cx,0018h
Wait15us_in:    out     5Fh,al
               loop     Wait15us_in
                pop     cx
                ret
Wait15us        ENDP
