/* write rom data */
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>

FILE *createFile(char *filename)
{
    FILE *f = fopen(filename, "wb");
    if(f == NULL) {
        fprintf(stderr, "\nt@C̍쐬Ɏs܂.𒆒f܂\n");
    }
    return f;
}

FILE *openFile(char *filename)
{
    FILE *f = fopen(filename, "rb");
    if(f == NULL) {
        fprintf(stderr, "\nt@C̃I[vɎs܂.𒆒f܂\n");
    }
    return f;
}

int writetoFile(FILE *f, void *buf, size_t size)
{
    size_t result;
    result = fwrite(buf, 1, size, f);
    if(result < size) {
        fprintf(stderr, "\nt@C̏݃G[ł.𒆒f܂\n");
        return 0;
    }
    return 1;
}

int readFile(FILE *f, void *buf, size_t size)
{
    size_t result;
    result = fread(buf, 1, size, f);
    if(result < size) {
        fprintf(stderr, "\nt@C̓ǂݏoG[ł.𒆒f܂\n");
        return 0;
    }
    return 1;
}

void inquiryScsi(void)
{
    int i, j;
    int detect = 0;
    unsigned char cmd[] = { 0x00, 0x44, 0x00, 0x00,
                            0x12, 0x00, 0x00, 0x00, 0x24, 0x00,
                            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, };
    unsigned char data[40];
    union REGS inregs, outregs;
    struct SREGS segregs;

    printf("SCSIڑCD-ROMhCu܂\n");

    for(i = 0; i < 8; i++) {
        memset(data, 0, 40);
        inregs.x.ax = 0x09c0 + i;
        inregs.x.cx = 0x0024;
        inregs.x.dx = FP_OFF(cmd);
        inregs.x.bx = FP_OFF(data);
        segregs.ds = FP_SEG(data);
        segregs.es = FP_SEG(cmd);
        int86x(0x1b, &inregs, &outregs, &segregs);
        if((outregs.h.ah & 0x20) != 0) {
            continue;
        }
        if(data[0] != 0x05) {
            continue;
        }
        printf("\nID:%d CD-ROMhCuo܂\n", i);
        printf("Vendor ID  : [");
        for(j = 8; j < 16; j++) {
            printf("%c", data[j]);
        }
        printf("]\nProduct ID : [");
        for(; j < 32; j++) {
            printf("%c", data[j]);
        }
        printf("]\n");
        detect++;
    }
    if(detect > 0) {
        printf("\noCD-ROMhCuG~[^Ŏgpꍇ,\n");
        printf("CD-ROM^uVendor ID, Product ID̊eڂɏL̓eݒ肵Ă\n");
    }
}

//int main(int argc, char *argv[])
int main(void)
{
    unsigned int i, j, k;
    unsigned int seg;
    size_t size;
    unsigned char pdata;
    unsigned char sum1, sum2;
    char c;
    void *buf;
    unsigned short *dst;
    unsigned char *cdst;
    FILE *f;

    printf("--- ROMC[W쐬c[ ---\n");
    printf("{c[EMM386.EXẺz86[hœ삷hCogpĂ\n");
    printf("t@C쐬ȂƂ܂\n");
    printf("SCSI,SOUNDɂĂ̓fBbvXCb`ŋ@\𖳌ɂĂꍇ,\n");
    printf("BIOSǂݏoȂ,OɃfBbvXCb`ŋ@\LɂĂĂ\n");
    printf("\n쐬p܂(y/N)");
    scanf("%c", &c);
    if((c != 'y') && (c != 'Y')) {
        exit(-1);
    }
    buf = calloc(0x8000, sizeof(char));
    printf("AhXE8000hFFFFFh͈̔͂BIOS.ROMƂĕۑ܂ ... ");
    f = createFile("BIOS.ROM");
    if(f == NULL) {
        free(buf);
        exit(-1);
    }
    for(seg = 0xe800; seg != 0; seg += 0x800) {
        dst = buf;
        for(i = 0; i < 0x8000; i += 2) {
            *dst++ = peek(seg, i);
        }
        if(writetoFile(f, buf, 0x8000) == 0) {
            fclose(f);
            free(buf);
            exit(-1);
        }
    }
    fclose(f);
    printf("\n");

    printf("AhXF8000hFFFFFh̗ROMITF.ROMƂĕۑ܂ ... ");
    f = createFile("ITF.ROM");
    if(f == NULL) {
        free(buf);
        exit(-1);
    }
    seg = 0xf800;
    disable();
    outportb(0x43d, 0);
    //outportb(0x43f, 0xe8);
    dst = buf;
    for(i = 0; i < 0x8000; i += 2) {
        *dst++ = peek(seg, i);
    }
    outportb(0x43d, 0x12);
    //outportb(0x53d, 0x22);
    enable();
    if(writetoFile(f, buf, 0x8000) == 0) {
        fclose(f);
        free(buf);
        exit(-1);
    }
    fclose(f);
    printf("\n");

    printf("AhXF8000hFFFFFh̃oN؂ւROMBANK.ROMƂĕۑ܂ ... ");
    f = createFile("BANK.ROM");
    if(f == NULL) {
        free(buf);
        exit(-1);
    }
    seg = 0xf800;
    for(pdata = 0xe0; pdata < 0xe8; pdata += 2) {
        disable();
        outportb(0x43d, 0);
        outportb(0x43f, pdata);
        dst = buf;
        for(i = 0; i < 0x8000; i += 2) {
            *dst++ = peek(seg, i);
        }
        outportb(0x43f, 0xe8);
        outportb(0x43d, 0x12);
        //outportb(0x53d, 0x22);
        enable();
        if(writetoFile(f, buf, 0x8000) == 0) {
            fclose(f);
            free(buf);
            exit(-1);
        }
    }
    fclose(f);
    printf("\n");

    printf("AhXCC000hCFFFFhSOUND BIOSSNDBIOS.ROMƂĕۑ܂ ... ");
    f = createFile("SNDBIOS.ROM");
    if(f == NULL) {
        free(buf);
        exit(-1);
    }
    seg = 0xcc00;
    disable();
    dst = buf;
    for(i = 0; i < 0x4000; i += 2) {
        *dst++ = peek(seg, i);
    }
    enable();
    if(writetoFile(f, buf, 0x4000) == 0) {
        fclose(f);
        free(buf);
        exit(-1);
    }
    fclose(f);
    printf("\n");

    printf("AhXD8000hD9FFFhIDE BIOSIDEBIOS.ROMƂĕۑ܂ ... ");
    f = createFile("IDEBIOS.ROM");
    if(f == NULL) {
        free(buf);
        exit(-1);
    }
    seg = 0xd800;
    disable();
    dst = buf;
    for(i = 0; i < 0x2000; i += 2) {
        *dst++ = peek(seg, i);
    }
    enable();
    if(writetoFile(f, buf, 0x2000) == 0) {
        fclose(f);
        free(buf);
        exit(-1);
    }
    fclose(f);
    printf("\n");

    printf("AhXDC000hDCFFFhSCSI BIOSSCSIBIOS.ROMƂĕۑ܂ ... ");
    f = createFile("SCSIBIOS.ROM");
    if(f == NULL) {
        free(buf);
        exit(-1);
    }
    seg = 0xdc00;
    disable();
    outportb(0x0cc0, 0x30);
    pdata = inportb(0x0cc2);
    outportb(0x0cc0, 0x30);
    outportb(0x0cc2, pdata & 0xbf);
    outportb(0x043f, 0xc0);
    dst = buf;
    for(i = 0; i < 0x1000; i += 2) {
        *dst++ = peek(seg, i);
    }
    outportb(0x0cc0, 0x30);
    outportb(0x0cc2, pdata | 0x40);
    outportb(0x043f, 0xc0);
    for(i = 0; i < 0x1000; i += 2) {
        *dst++ = peek(seg, i);
    }
    outportb(0x0cc0, 0x30);
    outportb(0x0cc2, pdata);
    outportb(0x043f, 0xc2);
    outportb(0x043f, 0xc4);
    enable();
    if(writetoFile(f, buf, 0x2000) == 0) {
        fclose(f);
        free(buf);
        exit(-1);
    }
    fclose(f);
    printf("\n");

    printf("tHgf[^t@C쐬܂.̍쐬ɂ͎Ԃ܂\n");
    printf("܂t@C쐬ʂ邱Ƃ܂,ł͂܂\n");
    f = createFile("FONT.DAT");
    if(f == NULL) {
        free(buf);
        exit(-1);
    }
    disable();
    outportb(0x68, 0x0a);
    outportb(0x68, 0x06);
    cdst = buf;
    for(i = 0; i < 256; i++) {
        outportb(0xa1, 0);
        outportb(0xa3, i);
        if((i % 4) == 0) {
            j = 0;
            while((inportb(0x60) & 0x20) != 0) {
                j++;
                j++;
            }
            while((inportb(0x60) & 0x20) == 0) {
                j++;
                j++;
            }
        }
        for(j = 0; j < 8; j++) {
            outportb(0xa5, j);
            *cdst++ = inportb(0xa9);
        }
    }
    outportb(0x68, 0x07);
    for(i = 0; i < 256; i++) {
        outportb(0xa1, 0);
        outportb(0xa3, i);
        if((i % 2) == 0) {
            j = 0;
            while((inportb(0x60) & 0x20) != 0) {
                j++;
                j++;
            }
            while((inportb(0x60) & 0x20) == 0) {
                j++;
                j++;
            }
        }
        for(j = 0; j < 16; j++) {
            outportb(0xa5, j);
            *cdst++ = inportb(0xa9);
        }
    }
    enable();
    if(writetoFile(f, buf, 256 * (8 + 16)) == 0) {
        fclose(f);
        free(buf);
        exit(-1);
    }
    printf(".");
    outportb(0x68, 0x0b);
    for(k = 0x20; k < 0x80; k++) {
        cdst = buf;
        disable();
        for(i = 0x01; i < 0x5d; i++) {
            outportb(0xa1, k);
            outportb(0xa3, i);
            for(j = 0; j < 16; j++) {
                outportb(0xa5, j | 0x20);
                *cdst++ = inportb(0xa9);
            }
            for(j = 0; j < 16; j++) {
                outportb(0xa5, j);
                *cdst++ = inportb(0xa9);
            }
        }
        printf(".");
        enable();
        if(writetoFile(f, buf, 92 * 32) == 0) {
            fclose(f);
            free(buf);
            exit(-1);
        }
    }
    fclose(f);
    outportb(0x68, 0x0a);
    printf("\n");

    printf("BIOS.ROM̃`FbN...");
    f = openFile("BIOS.ROM");
    if(f == NULL) {
        free(buf);
        exit(-1);
    }
    if(readFile(f, buf, 0x8000) == 0) {
        fclose(f);
        free(buf);
        exit(-1);
    }
    sum1 = 0;
    sum2 = 0;
    cdst = buf;
    for(i = 0; i < 0x8000; i += 2) {
        sum1 += *cdst++;
        sum2 += *cdst++;
    }
    if(readFile(f, buf, 0x8000) == 0) {
        fclose(f);
        free(buf);
        exit(-1);
    }
    cdst = buf;
    for(i = 0; i < 0x8000; i += 2) {
        sum1 += *cdst++;
        sum2 += *cdst++;
    }
    if(readFile(f, buf, 0x8000) == 0) {
        fclose(f);
        free(buf);
        exit(-1);
    }
    fclose(f);
    cdst = buf;
    for(i = 0; i < 0x8000; i += 2) {
        sum1 += *cdst++;
        sum2 += *cdst++;
    }
    printf(((sum1 | sum2) == 0) ? "OK\n" : "NG\n");

    printf("ITF.ROM̃`FbN...");
    f = openFile("ITF.ROM");
    if(f == NULL) {
        free(buf);
        exit(-1);
    }
    if(readFile(f, buf, 0x8000) == 0) {
        fclose(f);
        free(buf);
        exit(-1);
    }
    fclose(f);
    sum1 = 0;
    sum2 = 0;
    cdst = buf;
    for(i = 0; i < 0x8000; i += 2) {
        sum1 += *cdst++;
        sum2 += *cdst++;
    }
    printf(((sum1 | sum2) == 0) ? "OK\n" : "NG\n");

    printf("SNDBIOS.ROM̃`FbN...");
    f = openFile("SNDBIOS.ROM");
    if(f == NULL) {
        free(buf);
        exit(-1);
    }
    if(readFile(f, buf, 0x4000) == 0) {
        fclose(f);
        free(buf);
        exit(-1);
    }
    fclose(f);
    sum1 = 0;
    sum2 = 0;
    cdst = buf;
    for(i = 0; i < 0x4000; i += 2) {
        sum1 += *cdst++;
        sum2 += *cdst++;
    }
    printf(((sum1 | sum2) == 0) ? "OK\n" : "NG\n");

    printf("IDEBIOS.ROM̃`FbN...");
    f = openFile("IDEBIOS.ROM");
    if(f == NULL) {
        free(buf);
        exit(-1);
    }
    if(readFile(f, buf, 0x2000) == 0) {
        fclose(f);
        free(buf);
        exit(-1);
    }
    fclose(f);
    sum1 = 0;
    sum2 = 0;
    cdst = buf;
    for(i = 0; i < 0x2000; i += 2) {
        sum1 += *cdst++;
        sum2 += *cdst++;
    }
    printf(((sum1 | sum2) == 0) ? "OK\n" : "NG\n");

    printf("SCSIBIOS.ROM̃`FbN...");
    f = openFile("SCSIBIOS.ROM");
    if(f == NULL) {
        free(buf);
        exit(-1);
    }
    if(readFile(f, buf, 0x2000) == 0) {
        fclose(f);
        free(buf);
        exit(-1);
    }
    fclose(f);
    sum1 = 0;
    sum2 = 0;
    cdst = buf;
    for(i = 0; i < 0x2000; i += 2) {
        sum1 += *cdst++;
        sum2 += *cdst++;
    }
    printf(((sum1 | sum2) == 0) ? "OK\n" : "NG\n");

    if((sum1 | sum2) == 0) {
        inquiryScsi();
    }

    printf("vO͐ɏI܂.\n");
    free(buf);
    return 0;
}