#include <stdio.h>
#include <stdlib.h>
#include <dos.h>

const short diff = 0xf0;
const long rtmsize[8] = { 8832, 8064, 30080, 15104, 11520, 6272, 0, 0};


FILE *createFile(char *filename)
{
    FILE *f = fopen(filename, "wb");
    if(f == NULL) {
        fprintf(stderr, "\nt@C̍쐬Ɏs܂.𒆒f܂\n");
    }
    return f;
}

int writetoFile(FILE *f, const void *buf, size_t size)
{
    size_t result;
    result = fwrite(buf, 1, size, f);
    if(result < size) {
        fprintf(stderr, "\nt@C̏݃G[ł.𒆒f܂\n");
        fclose(f);
        exit(-1);
    }
    return 1;
}

void fm_out(unsigned char adr, unsigned char data)
{
    while((inportb(0x188) & 0x80) != 0);
    outportb(0x188, adr);
    outportb(0x18a, data);
}

void record_rhythm(short *buf, int type)
{
    long i;
    short data;
    outportb(0xa468, 0x40);
    outportb(0xa46a, 0x22);
    while((inportb(0xa466) & 0x40) == 0) {
        inportb(0xa46c);
    }
    // start
    outportb(0xa468, 0xc0);
    outportb(0xa46a, 0xa2);
    fm_out(0x10, 1 << type);

    for(i = 0; i < rtmsize[type]; i++) {
        while((inportb(0xa466) & 0x40) != 0);
        data  = inportb(0xa46c) << 8;
        while((inportb(0xa466) & 0x40) != 0);
        data |= inportb(0xa46c);
        buf[i] = data - diff;
    }
    // stop
    outportb(0xa468, 0x40);
    outportb(0xa46a, 0x22);
    fm_out(0x10, 0xbf);
}

int main(int argc, char *argv[])
{
    unsigned char data;
    short *buf = (short *)calloc(sizeof(short), 31000);
    FILE *f;

    if(buf == NULL) {
        printf("buffer allocation error\n");
        exit(0);
    }
    f = createFile("rhythm.dat");
    if(f == NULL) {
        exit(0);
    }

    writetoFile(f, rtmsize, 32);

    // set mix volume
    outportb(0xa466, 0x20);
    outportb(0xa466, 0x6f);
    outportb(0xa466, 0x00);
    // enable opna
    data = inportb(0xa460);
    if((data & 0x01) == 0) {
        outportb(0xa460, data | 1);
    }
    // initialize rhythm volume
    fm_out(0x10, 0xbf);
    fm_out(0x11, 0x3f);
    fm_out(0x18, 0xdf);
    fm_out(0x19, 0xdf);
    fm_out(0x1a, 0xdf);
    fm_out(0x1b, 0xdf);
    fm_out(0x1c, 0xdf);
    fm_out(0x1d, 0xdf);
    // initialize pcm
    outportb(0xa468, 0x08);
    outportb(0xa468, 0x00);

    record_rhythm(buf, 0);
    writetoFile(f, buf, rtmsize[0] * sizeof(short));
    record_rhythm(buf, 1);
    writetoFile(f, buf, rtmsize[1] * sizeof(short));
    record_rhythm(buf, 2);
    writetoFile(f, buf, rtmsize[2] * sizeof(short));
    record_rhythm(buf, 3);
    writetoFile(f, buf, rtmsize[3] * sizeof(short));
    record_rhythm(buf, 4);
    writetoFile(f, buf, rtmsize[4] * sizeof(short));
    record_rhythm(buf, 5);
    writetoFile(f, buf, rtmsize[5] * sizeof(short));

    outportb(0xa468, 0x08);
    outportb(0xa468, 0x00);

    free(buf);
    fclose(f);
    return 0;
}